/*****************************************************************************
 *
 *  Copyright (C) 2003 Cdric Brgardis <cedric.bregardis@free.fr>
 *
 *  This file is part of BRIQUOLO
 *
 *  BRIQUOLO is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  BRIQUOLO is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with BRIQUOLO; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/
#include "ElementOptionBool.h"

ElementOptionBool::ElementOptionBool(const string & p_Nom, bool p_ParametreDefaut)
  : ElementOption(p_Nom), _Parametre(p_ParametreDefaut)
{
}

bool ElementOptionBool::Charger(ifstream & p_Fichier)
{
  streampos position=p_Fichier.tellg();
  string nom, parametre;
  p_Fichier>>nom>>parametre;
  if (p_Fichier.good() && nom==_Nom)
  {

    _Parametre=(parametre=="1");
    return true;
  }
  else
  {
    p_Fichier.seekg(position);
    return false;
  }
}

bool ElementOptionBool::Sauver(ofstream & p_Fichier)
{
  string res;
  if (_Parametre)
  {
    res="1";
  }
  else
  {
    res="0";
  }
  p_Fichier<<_Nom<<' '<<res<<endl;
  return p_Fichier.good();
}

bool ElementOptionBool::GetValeur() const
{
  return _Parametre;
}

void ElementOptionBool::SetValeur(bool p_Valeur)
{
  _Parametre=p_Valeur;
}
